@echo off
rem The Wizard's Apprentice Installer 1.00
rem Example file that goes with the Wizard's Apprentice.
rem The Wizard's Apprentice may be freely distributed.
rem See license for details.

rem Set the title, the bitmap and the return batch file
rem for this wizard, and initialise all ather wa
rem variables in case any old values are left over.
set wabmp=
set watitle=Wizard's Apprentice Installation 1.00
set wabat=%TEMP%\wabat.bat
rem remove any leftovers
set waprefix=
set waeol=
set wainput=
set wafile=
set walistsep=
set walabels=
set wasig=
set waico=
set waoutput=
set waoutnum=
rem Initialise the variables this wizard needs.
set notinpath=0
set installdir=
set i0=1
set i1=1
set installgroup=Wizard's Apprentice
rem Start the wizard.

:page1
rem We set the page variable to be able to return here
rem after a Cancel request.
set page=:page1
set watext=Welcome to the Wizard's Apprentice setup
set watext=%watext%~~This installation program will install the Wizard's Apprentice.
set watext=%watext%~~The Wizard's Apprentice adds an interface to your batch programs:
set watext=%watext%~~* Use message boxes for simple questions
set watext=%watext%~* Tickboxes, radiobuttons and listboxes for more complicated questions
set watext=%watext%~* Display files, e.g. licenses
set watext=%watext%~* Configurable buttons, picture and title
set watext=%watext%~* File and directory box with Browse button
set watext=%watext%~* Sample batch files and comprehensive manual
set watext=%watext%~~... and the Wizard's Apprentice is free!
set watext=%watext%~~Press the [Next] button to start the installation.
start /w wizapp NOBACK TB
if errorlevel 2 goto :cancel
rem no Back possible

:page2
set page=:page2
set watext=Software License Agreement
set watext=%watext%~~Although the Wizard's Apprentice is free, there still is a license, which means as much as: "Don't blame me when anything goes wrong". Hit the [I Accept] button to continue installing.
rem wafile contains the contents for the license box.
set wafile=license.txt
set wainput=
rem The ^ is necessary to escape the ampersand on NT,
rem The ampersand puts in a hotkey.
if "%OS%"=="Windows_NT" set walabels=;I ^&Accept;;I ^&Disagree;
if not "%OS%"=="Windows_NT" set walabels=;I &Accept;;I &Disagree;
start /w wizapp FT
rem Don't forget to immediately set wafile to empty;
rem if both wafile and wainput are set, wafile wins.
set wafile=
rem And set the labels back to normal.
set walabels=
if errorlevel 2 goto :exit
if errorlevel 1 goto page1

:page3
set page=:page3
set watext=Do you want to install the Wizard's Apprentice in a directory in your PATH?
set watext=%watext%~~If you install in your PATH, the Wizard's Apprentice will be available everywhere on you computer.
set watext=%watext%~If you don't, it has to reside in the same directory as the batch file that uses it.
rem Set the radiobutton options
if "%OS%"=="Windows_NT" set wainput=Install in my ^&PATH;Install in ^&another directory
if not "%OS%"=="Windows_NT" set wainput=Install in my &PATH;Install in &another directory
rem Set the initially checked choice
set waoutnum=%notinpath%
set waoutput=
start /w wizapp RB
if errorlevel 2 goto :cancel
if errorlevel 1 goto page2
rem Retrieve the user's choice
call %wabat%
rem and store it
set notinpath=%waoutnum%

rem Now we have the choice: Either we show a dialog
rem that shows all directories in the path, or we show
rem a normal directory browser.  First comes the PATH
rem chooser.
:page4
rem Check whether we should display this page at all;
rem skip it if we shouldn't.  The user can come from
rem the previous page (after pressing the Next button)
rem or from the next page (with the Back button);
rem handle both case.
if %notinpath%==1 if %page%==:page3 goto :page5
if %notinpath%==1 if %page%==:page5 goto :page3
rem Now that we got here, we do want to display this
rem page.
set page=:page4
set watext=Select Destination Directory in your PATH
set watext=%watext%~~~~Please select the directory in your PATH where the Wizard's Apprentice should be installed.
set waoutput=%installdir%
set waoutnum=
set wainput=%PATH%
start /w wizapp LB SINGLE
if errorlevel 2 goto :cancel
if errorlevel 1 goto page3
rem Retrieve the user's choice
call %wabat%
rem and store it
set installdir=%waoutput%

rem Next comes the normal directory browser. 
:page5
if %notinpath%==0 if %page%==:page4 goto :page6
if %notinpath%==0 if %page%==:page6 goto :page4
set page=:page5
set watext=Select Destination Directory
set watext=%watext%~~~~Please select the directory where the Wizard's Apprentice should be installed.
set waoutput=%installdir%
set waoutnum=
start /w wizapp FB DIR
if errorlevel 2 goto :cancel
if errorlevel 1 goto page4
rem Retrieve the user's choice
call %wabat%
rem and store it
set installdir=%waoutput%

:page6
set page=:page6
set watext=Icon Creation
set watext=%watext%~~~~Should the installer create a desktop icon or a shortcut in the start menu for the Wizard's Apprentice's Manual?
if "%OS%"=="Windows_NT" set wainput=Add manual to ^&Start Menu;Add manual icon to ^&Desktop
if not "%OS%"=="Windows_NT" set wainput=Add manual to &Start Menu;Add manual icon to &Desktop
rem By setting waoutnum we specify the default value. 
set waoutnum=
if %i0%==1 set waoutnum=0;
if %i1%==1 set waoutnum=%waoutnum%1;
set waoutput=
start /w wizapp CL
if errorlevel 2 goto :cancel
if errorlevel 1 goto page5
call %wabat%
rem Here's a trick to dissect the list that was
rem returned. These for commands create variables named
rem i0, i1
for %%n in (0 1) do set i%%n=0
rem i0 is only set if 0 is in the list. i1 will only be
rem set if 1 is in the list, etc.
for %%n in (%waoutnum%) do set i%%n=1

:page7
rem Here we have another page that we sometimes must
rem skip, depending on the value of i0.  
if "%i0%"=="0" if %page%==:page6 goto page8
if "%i0%"=="0" if %page%==:page8 goto page6
set page=:page7
rem find all the groups in the user's start menu.
set userdir=%USERPROFILE%
rem USERPROFILE is not set on Windows 95/98.
rem This solution isn't entirely correct on 
rem Windows 9x, as you might have profiles
rem enabled, but it is better than nothing.
rem For a better solution, see the websites
rem referred to in the manual.
if "%USERPROFILE%"=="" set userdir=%windir%
rem If wafile is set, it's contents will be 
rem used instead of wainput. So we build the
rem directory list in a file. Note that 
rem walistsep is not used then; every line
rem is an item.
set wafile=%TEMP%\wafile
rem dir /ad lists only directories, /b means 
rem bare output (only names)
dir /ad /b "%userdir%\Start Menu\Programs" > %wafile%
set wainput=
rem Now we have the list for the combobox; Setting
rem waoutput sets the default for the combobox's
rem editfield.
set waoutput=%installgroup%
set waoutnum=
set watext=Select Group
set watext=%watext%~~~~Enter the name of program group to add the manual icon to.
start /w wizapp CB
rem Don't forget to immediately set wafile to empty;
rem if both wafile and wainput are set, wafile wins.
set wafile=
if errorlevel 2 goto :cancel
if errorlevel 1 goto page6
call %wabat%
set installgroup=%waoutput%

:page8
set page=:page8
set watext=Ready to Install!
set watext=%watext%~~~~Press the [Install] button to begin the installation or the [Back] button to reenter the installation information.~
set wainput=Installation directory: %installdir%
if %i0%==1 set wainput=%wainput%~Install a shortcut to the manual in program group: %installgroup%
if %i1%==1 set wainput=%wainput%~Install a shortcut to the manual on your Desktop
if "%OS%"=="Windows_NT" set walabels=;;^&Install;;
if not "%OS%"=="Windows_NT" set walabels=;;&Install;;
rem Here we use a file text box with only a few
rem lines of text, so we use wainput instead of 
rem wafile.
start /w wizapp FINISH FT
if errorlevel 2 goto :cancel
if errorlevel 1 goto page7

rem Here we are, after the user pressed the Install
rem button. Let's install!  Just create the directory
rem and ignore the error message if it does not work.
mkdir "%installdir%"
rem By specifying a complete path name for the
rem destination we make sure the copy fails if the
rem directory name is not valid.
for %%f in ("wizapp.exe" "wainstall.bat" "wizapp.css" "index.html" "manual.html"  "download.html" "*.png" "*.txt") do copy "%%f" "%installdir%\%%f"
rem No create the shortcut, first in %TEMP%
set linkname=The Wizard's Apprentice's Manual
rem Create an .inf file, also in %TEMP%
echo [version]                  > %TEMP%\tmp.inf
echo signature=$chicago$        >> %TEMP%\tmp.inf
echo [DefaultInstall]           >> %TEMP%\tmp.inf
echo UpdateInis=AddLink         >> %TEMP%\tmp.inf
echo [AddLink]                  >> %TEMP%\tmp.inf
echo setup.ini, progman.groups,, ""group1="%TEMP%""" >> %TEMP%\tmp.inf
echo setup.ini, group1,, """%linkname%"", ""%installdir%\manual.html""" >> %TEMP%\tmp.inf
rem Create the link
start /w rundll32.exe setupapi,InstallHinfSection DefaultInstall 132 %TEMP%\tmp.inf
del %TEMP%\tmp.inf
rem Copy it to wherever we wanted
if i0==0 goto :desktop
rem Just create the directory and ignore the error
rem message if it does work.
mkdir "%userdir%\Start Menu\Programs\%installgroup%"
rem Again, by using the full name the copying is
rem reasonably safe.
copy "%TEMP%\%linkname%.lnk" "%userdir%\Start Menu\Programs\%installgroup%\%linkname%.lnk"
:desktop
if i1==0 goto :linkdone
copy "%TEMP%\%linkname%.lnk" "%userdir%\Desktop\%linkname%.lnk"
:linkdone
set watext=Installation completed!
start /w wizapp MB INFO

goto :exit

:cancel
set watext=Do you want to abort this installation?
start /w wizapp MB QUES
if errorlevel 2 goto %page%

:exit
if exist %wabat% del %wabat%
set userdir=
set installdir=
set installgroup=
set linkname=
set notinpath=
set page=
set i0=
set i1=

set watitle=
set watext=
set wainput=
set wafile=
set wabmp=
set walabels=
set wasig=
set waico=
set wabat=
set waoutput=
set waoutnum=
